#include <stdio.h>
#include <string.h>

#define LETTERCOUNT 20
#define NUMBEROFEVENTS 4

int lettersInArray=LETTERCOUNT;
int i;   
int j;
char bingoArray[20]={'a','c','b','g','k','v','n',
					'm','l','s','e','t','y','w',
					'f','d','v','z','x','e'};
char input;
int found = 0;
int running = 1;
int currentSlot = 0;

void displayLetters(){
	printf("\n");
	for(i=0;i<lettersInArray;){
		printf("%c ",bingoArray[i++]);
		if(i%5==0){
			printf("\n\n");
		}
	}
	printf("\n");
}

void checkForEndOfGame(){
	if(lettersInArray==0){
		running = 0;
		printf("Bingo!\n");
	}
}

void readInput(){
	scanf("%c",&input);
}

void updateLetters(){
	j=0;
	found = 0;
	for(j=0;j<lettersInArray;j++){
		if(bingoArray[j]==input){
			found = 1;
			lettersInArray--;
		}
		if(found){
			bingoArray[j]=bingoArray[j+1];
		}
	}
	scanf("%c",&input);
}

void (*table[NUMBEROFEVENTS])() = 
{displayLetters, readInput, updateLetters, checkForEndOfGame};

int main(int argc, char *argv[]){

	printf("Welcome to blind bingo\n");
	printf("enter letter to begin\n\n");
	while(running){
		for(currentSlot=0; currentSlot<NUMBEROFEVENTS;currentSlot++){
			(*table[currentSlot])();
		}
	}
}
